<?php
/**
 * The Template for displaying all single products
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see         https://docs.woocommerce.com/document/template-structure/
 * @package     WooCommerce\Templates
 * @version     1.6.4
 * LaunchFlows since 3.5.3
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

get_header( 'shop' ); 


		/**
		 * woocommerce_before_main_content hook.
		 *
		 * @hooked woocommerce_output_content_wrapper - 10 (outputs opening divs for the content)
		 * @hooked woocommerce_breadcrumb - 20
		 */
		
		do_action( 'woocommerce_before_main_content' );

	?>

		<?php while ( have_posts() ) : ?>
			<?php the_post(); ?>



			<?php // LaunchFlows Conditional Product Content Template Output
				// set original template if no other selected
				
			    $template_choice = get_post_meta( $post->ID, '_lf_custom_product_template_field', true );

			    if( ! empty( $template_choice ) ){

			    $template =  plugin_dir_path( __FILE__ ) . 'product-templates/single-product-'.$template_choice.'.php';

				} else {

			    $template = plugin_dir_path( __FILE__ ) . 'product-templates/single-product-original.php';

				}
				// echo $template;
				include_once($template );
			?>



	<?php endwhile; // end of the loop. ?>


	<?php
		/**
		 * woocommerce_after_main_content hook.
		 *
		 * @hooked woocommerce_output_content_wrapper_end - 10 (outputs closing divs for the content)
		 */
		do_action( 'woocommerce_after_main_content' );
	?>

	<?php
		/**
		 * woocommerce_sidebar hook.
		 *
		 * @hooked woocommerce_get_sidebar - 10
		 */
		do_action( 'woocommerce_sidebar' );
	?>

<?php
get_footer( 'shop' );

/* Omit closing PHP tag at the end of PHP files to avoid "headers already sent" issues. */