<?php
if ( ! defined( 'ABSPATH' ) ) {
  exit; // Exit if accessed directly
}


/**
   * Adds Block Pattern Category of LaunchFlows and Patterns To Gutenberg
   *
   * @since 3.5.3
   *
   * @return void
   */

add_action( 'init', 'lf_register_block_patterns' );

function lf_register_block_patterns() {

    // Registering a block category
    register_block_pattern_category('launchflows',array( 'label' => __( 'LaunchFlows', 'lf' ) ) );
    
    if ( class_exists( 'WP_Block_Patterns_Registry' ) ) {

  
        // start block pattern
        register_block_pattern(
            'launchflows/checkout-one-column',
                array(
                'categories'  => array( 'launchflows' ),
                'title'       => __( 'One Column Checkout', 'lf' ),
                'description' => _x( 'One Column Checkout', 'Block pattern description', 'lf' ),
                'content'     => "              
                <!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:launchflows/notices -->\n<div class=\"wp-block-launchflows-notices\">[lf-notices]</div>\n<!-- /wp:launchflows/notices -->\n\n<!-- wp:launchflows/login -->\n<div class=\"wp-block-launchflows-login\">[lf-login]</div>\n<!-- /wp:launchflows/login -->\n\n<!-- wp:launchflows/review -->\n<div class=\"wp-block-launchflows-review\">[lf-review]</div>\n<!-- /wp:launchflows/review -->\n\n<!-- wp:launchflows/billing -->\n<div class=\"wp-block-launchflows-billing\">[lf-billing]</div>\n<!-- /wp:launchflows/billing -->\n\n<!-- wp:launchflows/shipping -->\n<div class=\"wp-block-launchflows-shipping\">[lf-shipping]</div>\n<!-- /wp:launchflows/shipping -->\n\n<!-- wp:launchflows/wccoupon -->\n<div class=\"wp-block-launchflows-wccoupon\">[lf-wccoupon]</div>\n<!-- /wp:launchflows/wccoupon -->\n\n<!-- wp:launchflows/payment -->\n<div class=\"wp-block-launchflows-payment\">[lf-payment]</div>\n<!-- /wp:launchflows/payment -->\n\n<!-- wp:launchflows/additional -->\n<div class=\"wp-block-launchflows-additional\">[lf-additional]</div>\n<!-- /wp:launchflows/additional --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->
                ", // end content
              )
            );
        // end block pattern

        // start block pattern
        register_block_pattern(
            'launchflows/checkout-two-column',
                array(
                'categories'  => array( 'launchflows' ),
                'title'       => __( 'Two Column Checkout', 'lf' ),
                'description' => _x( 'Two Column Checkout', 'Block pattern description', 'lf' ),
                'content'     => "              
                <!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:launchflows/billing -->\n<div class=\"wp-block-launchflows-billing\">[lf-billing]</div>\n<!-- /wp:launchflows/billing -->\n\n<!-- wp:launchflows/shipping -->\n<div class=\"wp-block-launchflows-shipping\">[lf-shipping]</div>\n<!-- /wp:launchflows/shipping -->\n\n<!-- wp:launchflows/notices -->\n<div class=\"wp-block-launchflows-notices\">[lf-notices]</div>\n<!-- /wp:launchflows/notices -->\n\n<!-- wp:launchflows/login -->\n<div class=\"wp-block-launchflows-login\">[lf-login]</div>\n<!-- /wp:launchflows/login --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:launchflows/review -->\n<div class=\"wp-block-launchflows-review\">[lf-review]</div>\n<!-- /wp:launchflows/review -->\n\n<!-- wp:launchflows/wccoupon -->\n<div class=\"wp-block-launchflows-wccoupon\">[lf-wccoupon]</div>\n<!-- /wp:launchflows/wccoupon -->\n\n<!-- wp:launchflows/payment -->\n<div class=\"wp-block-launchflows-payment\">[lf-payment]</div>\n<!-- /wp:launchflows/payment -->\n\n<!-- wp:launchflows/additional -->\n<div class=\"wp-block-launchflows-additional\">[lf-additional]</div>\n<!-- /wp:launchflows/additional --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->
                ", // end content
              )
            );
        // end block pattern 
  
        // start block pattern 
        register_block_pattern(
            'launchflows/checkout-one-column-fse',
                array(
                'categories'  => array( 'launchflows' ),
                'title'       => __( 'One Column Checkout For FSE', 'lf' ),
                'description' => _x( 'One Column Checkout For FSE', 'Block pattern description', 'lf' ),
                'content'     => "              
                <!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:launchflows/checkout-form-start -->\n<div class=\"wp-block-launchflows-checkout-form-start\">[lf-checkout-form-start]</div>\n<!-- /wp:launchflows/checkout-form-start -->\n\n<!-- wp:launchflows/notices -->\n<div class=\"wp-block-launchflows-notices\">[lf-notices]</div>\n<!-- /wp:launchflows/notices -->\n\n<!-- wp:launchflows/login -->\n<div class=\"wp-block-launchflows-login\">[lf-login]</div>\n<!-- /wp:launchflows/login -->\n\n<!-- wp:launchflows/review -->\n<div class=\"wp-block-launchflows-review\">[lf-review]</div>\n<!-- /wp:launchflows/review -->\n\n<!-- wp:launchflows/billing -->\n<div class=\"wp-block-launchflows-billing\">[lf-billing]</div>\n<!-- /wp:launchflows/billing -->\n\n<!-- wp:launchflows/shipping -->\n<div class=\"wp-block-launchflows-shipping\">[lf-shipping]</div>\n<!-- /wp:launchflows/shipping -->\n\n<!-- wp:launchflows/wccoupon -->\n<div class=\"wp-block-launchflows-wccoupon\">[lf-wccoupon]</div>\n<!-- /wp:launchflows/wccoupon -->\n\n<!-- wp:launchflows/payment -->\n<div class=\"wp-block-launchflows-payment\">[lf-payment]</div>\n<!-- /wp:launchflows/payment -->\n\n<!-- wp:launchflows/additional -->\n<div class=\"wp-block-launchflows-additional\">[lf-additional]</div>\n<!-- /wp:launchflows/additional -->\n\n<!-- wp:launchflows/checkout-form-end -->\n<div class=\"wp-block-launchflows-checkout-form-end\">[lf-checkout-form-end]</div>\n<!-- /wp:launchflows/checkout-form-end --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->
                ", // end content
              )
            );
        // end block pattern
        
        // start block pattern
        register_block_pattern(
            'launchflows/checkout-two-column-fse',
                array(
                'categories'  => array( 'launchflows' ),
                'title'       => __( 'Two Column Checkout For FSE', 'lf' ),
                'description' => _x( 'Two Column Checkout Fpr FSE', 'Block pattern description', 'lf' ),
                'content'     => "              
                <!-- wp:launchflows/checkout-form-start -->\n<div class=\"wp-block-launchflows-checkout-form-start\">[lf-checkout-form-start]</div>\n<!-- /wp:launchflows/checkout-form-start -->\n\n<!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:launchflows/billing -->\n<div class=\"wp-block-launchflows-billing\">[lf-billing]</div>\n<!-- /wp:launchflows/billing -->\n\n<!-- wp:launchflows/shipping -->\n<div class=\"wp-block-launchflows-shipping\">[lf-shipping]</div>\n<!-- /wp:launchflows/shipping -->\n\n<!-- wp:launchflows/notices -->\n<div class=\"wp-block-launchflows-notices\">[lf-notices]</div>\n<!-- /wp:launchflows/notices -->\n\n<!-- wp:launchflows/login -->\n<div class=\"wp-block-launchflows-login\">[lf-login]</div>\n<!-- /wp:launchflows/login --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:launchflows/review -->\n<div class=\"wp-block-launchflows-review\">[lf-review]</div>\n<!-- /wp:launchflows/review -->\n\n<!-- wp:launchflows/wccoupon -->\n<div class=\"wp-block-launchflows-wccoupon\">[lf-wccoupon]</div>\n<!-- /wp:launchflows/wccoupon -->\n\n<!-- wp:launchflows/payment -->\n<div class=\"wp-block-launchflows-payment\">[lf-payment]</div>\n<!-- /wp:launchflows/payment -->\n\n<!-- wp:launchflows/additional -->\n<div class=\"wp-block-launchflows-additional\">[lf-additional]</div>\n<!-- /wp:launchflows/additional --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:launchflows/checkout-form-end -->\n<div class=\"wp-block-launchflows-checkout-form-end\">[lf-checkout-form-end]</div>\n<!-- /wp:launchflows/checkout-form-end -->
                ", // end content
              )
            );
        // end block pattern 
        // start block pattern 
        register_block_pattern(
            'launchflows/product-two-column',
                array(
                'categories'  => array( 'launchflows' ),
                'title'       => __( 'Two Column Product Layout', 'lf' ),
                'description' => _x( 'Two Column Product Layout', 'Block pattern description', 'lf' ),
                'content'     => "              
                <!-- wp:columns {\"className\":\"eplus-wrapper\"} -->\n<div class=\"wp-block-columns eplus-wrapper\"><!-- wp:column {\"className\":\"eplus-wrapper\"} -->\n<div class=\"wp-block-column eplus-wrapper\"><!-- wp:launchflows/productimages -->\n<div class=\"wp-block-launchflows-productimages\">[lf-product-images]</div>\n<!-- /wp:launchflows/productimages -->\n\n<!-- wp:launchflows/productbreadcrumb -->\n<div class=\"wp-block-launchflows-productbreadcrumb\">[lf-product-breadcrumb]</div>\n<!-- /wp:launchflows/productbreadcrumb -->\n\n<!-- wp:launchflows/productbreadcrumbs -->\n<div class=\"wp-block-launchflows-productbreadcrumbs\">[lf-product-breadcrumbs]</div>\n<!-- /wp:launchflows/productbreadcrumbs --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"className\":\"eplus-wrapper\"} -->\n<div class=\"wp-block-column eplus-wrapper\"><!-- wp:launchflows/producttitle -->\n<div class=\"wp-block-launchflows-producttitle\">[lf-product-title]</div>\n<!-- /wp:launchflows/producttitle -->\n\n<!-- wp:launchflows/productprice -->\n<div class=\"wp-block-launchflows-productprice\">[lf-product-price]</div>\n<!-- /wp:launchflows/productprice -->\n\n<!-- wp:launchflows/productdescription -->\n<div class=\"wp-block-launchflows-productdescription\">[lf-product-description]</div>\n<!-- /wp:launchflows/productdescription -->\n\n<!-- wp:launchflows/productaddtocart -->\n<div class=\"wp-block-launchflows-productaddtocart\">[lf-product-add-to-cart]</div>\n<!-- /wp:launchflows/productaddtocart -->\n\n<!-- wp:launchflows/productfirstpayment -->\n<div class=\"wp-block-launchflows-productfirstpayment\">[lf-product-firstpayment]</div>\n<!-- /wp:launchflows/productfirstpayment -->\n\n<!-- wp:launchflows/productmeta -->\n<div class=\"wp-block-launchflows-productmeta\">[lf-product-meta]</div>\n<!-- /wp:launchflows/productmeta --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns {\"className\":\"eplus-wrapper\"} -->\n<div class=\"wp-block-columns eplus-wrapper\"><!-- wp:column {\"className\":\"eplus-wrapper\"} -->\n<div class=\"wp-block-column eplus-wrapper\"><!-- wp:launchflows/producttabs -->\n<div class=\"wp-block-launchflows-producttabs\">[lf-product-tabs]</div>\n<!-- /wp:launchflows/producttabs -->\n\n<!-- wp:launchflows/productrelated -->\n<div class=\"wp-block-launchflows-productrelated\">[lf-product-related]</div>\n<!-- /wp:launchflows/productrelated --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->
                ", // end content
              )
            );
        // end block pattern         

        // start block pattern
        register_block_pattern(
            'launchflows/checkout-tab-ep',
                array(
                'categories'  => array( 'launchflows' ),
                'title'       => __( 'Tabbed Checkout (* Requires Editor Plus)', 'lf' ),
                'description' => _x( 'Tabbed Checkout (* Requires Editor Plus)', 'Block pattern description', 'lf' ),
                'content'     => "              
                <!-- wp:ep/tabs {\"epStylingOptions\":{\"tabsHeaderSizingResponsiveEnabled\":false,\"blockGapResponsiveEnabled\":false,\"titleTypographyResponsiveEnabled\":false,\"titleTypographyHoverEnabled\":true,\"subTitleTypographyResponsiveEnabled\":false,\"subTitleTypographyHoverEnabled\":true,\"titleActiveColorResponsiveEnabled\":false,\"subTitleActiveColorResponsiveEnabled\":false,\"titleBackgroundResponsiveEnabled\":false,\"titleBackgroundHoverEnabled\":true,\"titleActiveBackgroundResponsiveEnabled\":false,\"titleBorderResponsiveEnabled\":false,\"titleBorderHoverEnabled\":false,\"titleBorderRadiusResponsiveEnabled\":false,\"titleBorderRadiusHoverEnabled\":false,\"titleBoxShadowResponsiveEnabled\":false,\"titleBoxShadowHoverEnabled\":false,\"contentBackgroundResponsiveEnabled\":false,\"contentBackgroundHoverEnabled\":false,\"titlePaddingResponsiveEnabled\":false,\"contentBorderResponsiveEnabled\":false,\"contentBorderHoverEnabled\":false,\"contentBorderRadiusResponsiveEnabled\":false,\"contentBorderRadiusHoverEnabled\":false,\"contentBoxShadowResponsiveEnabled\":false,\"contentBoxShadowHoverEnabled\":false,\"contentPaddingResponsiveEnabled\":false,\"titleGapResponsiveEnabled\":false,\"titleAlignmentResponsiveEnabled\":false,\"tabsHeaderSizing\":{\"target\":\"ep_tabs_header\",\"responsive\":true,\"options\":[{\"label\":\"\",\"control\":\"Range\",\"attribute\":\"tabsHeaderSizing\",\"css\":\"flex-basis\",\"defaults\":{\"desktop\":\"15%\"},\"props\":{\"supportedUnits\":[\"%\"]}}]},\"blockGap\":{\"target\":\"ep_tabs_root\",\"responsive\":true,\"options\":[{\"label\":\"Gap\",\"control\":\"Range\",\"attribute\":\"blockGap\",\"css\":\"gap\",\"defaults\":{\"desktop\":\"0px\"},\"props\":{\"supportedUnits\":[\"px\"]}}]},\"titleTypography\":{\"target\":\"ep_label\",\"responsive\":true,\"hover\":true,\"hoverTarget\":\".ep_label_main:hover .ep_label\",\"options\":[{\"label\":\"Title Typography\",\"control\":\"Typography\",\"attribute\":\"titleTypography\",\"defaults\":{\"desktop\":{\"font-size\":\"17px\",\"text-color\":\"#1e1e1e\"},\"hover\":{\"text-color\":\"#ffffff\"}}}]},\"subTitleTypography\":{\"target\":\"ep_sub_label\",\"responsive\":true,\"hover\":true,\"hoverTarget\":\".ep_label_main:hover .ep_sub_label\",\"options\":[{\"label\":\"Sub Title Typography\",\"control\":\"Typography\",\"attribute\":\"subTitleTypography\",\"defaults\":{\"desktop\":{\"font-size\":\"15px\",\"text-color\":\"#1e1e1e\"},\"hover\":{\"text-color\":\"#ffffff\"}}}]},\"titleActiveColor\":{\"target\":\"ep_active_tab .ep_label\",\"responsive\":true,\"options\":[{\"label\":\"Active Color\",\"control\":\"ColorPicker\",\"css\":\"color\",\"attribute\":\"titleActiveColor\",\"defaults\":{\"desktop\":\"#ffffff\"}}]},\"subTitleActiveColor\":{\"target\":\"ep_active_tab .ep_sub_label\",\"responsive\":true,\"options\":[{\"label\":\"Sub Title Active Color\",\"control\":\"ColorPicker\",\"css\":\"color\",\"attribute\":\"subTitleActiveColor\",\"defaults\":{\"desktop\":\"#ffffff\"}}]},\"titleBackground\":{\"target\":\"ep_label_main\",\"responsive\":true,\"hover\":true,\"options\":[{\"label\":\"Title Background\",\"control\":\"Background\",\"attribute\":\"titleBackground\",\"defaults\":{\"desktop\":{\"solid\":\"#f0f0f0\"},\"hover\":{\"solid\":\"#007cba\"}}}]},\"titleActiveBackground\":{\"target\":\"ep_active_tab\",\"responsive\":true,\"options\":[{\"label\":\"Title Active Background\",\"control\":\"Background\",\"attribute\":\"titleActiveBackground\",\"defaults\":{\"desktop\":{\"solid\":\"#007cba\"}}}]},\"titleBorder\":{\"target\":\"ep_label_main\",\"responsive\":true,\"hover\":true,\"options\":[{\"label\":\"Border\",\"control\":\"Border\",\"attribute\":\"titleBorder\"}]},\"titleBorderRadius\":{\"target\":\"ep_label_main\",\"responsive\":true,\"hover\":true,\"options\":[{\"label\":\"Border Radius\",\"control\":\"Dimensions\",\"attribute\":\"titleBorderRadius\",\"css\":\"border-radius\"}]},\"titleBoxShadow\":{\"target\":\"ep_label_main\",\"responsive\":true,\"hover\":true,\"options\":[{\"label\":\"Shadow\",\"control\":\"Shadow\",\"attribute\":\"titleBoxShadow\",\"css\":\"box-shadow\"}]},\"contentBackground\":{\"target\":\"ep_tab_item_wrapper\",\"responsive\":true,\"hover\":true,\"options\":[{\"label\":\"Content Background\",\"control\":\"Background\",\"attribute\":\"contentBackground\",\"defaults\":{\"desktop\":{\"solid\":\"#f0f0f0\"}}}]},\"titlePadding\":{\"target\":\"ep_label_main\",\"responsive\":true,\"options\":[{\"label\":\"Title Padding\",\"control\":\"Dimensions\",\"attribute\":\"titlePadding\",\"css\":\"padding\",\"defaults\":{\"desktop\":\"15px 15px 15px 15px\"}}]},\"contentBorder\":{\"target\":\"ep_tab_item_wrapper\",\"responsive\":true,\"hover\":true,\"options\":[{\"label\":\"Border\",\"control\":\"Border\",\"attribute\":\"contentBorder\"}]},\"contentBorderRadius\":{\"target\":\"ep_tab_item_wrapper\",\"responsive\":true,\"hover\":true,\"options\":[{\"label\":\"Border Radius\",\"control\":\"Dimensions\",\"attribute\":\"contentBorderRadius\",\"css\":\"border-radius\"}]},\"contentBoxShadow\":{\"target\":\"ep_tab_item_wrapper\",\"responsive\":true,\"hover\":true,\"options\":[{\"label\":\"Shadow\",\"control\":\"Shadow\",\"attribute\":\"contentBoxShadow\",\"css\":\"box-shadow\"}]},\"contentPadding\":{\"target\":\"ep_tab_item_wrapper\",\"responsive\":true,\"options\":[{\"label\":\"Content Padding\",\"control\":\"Dimensions\",\"attribute\":\"contentPadding\",\"css\":\"padding\",\"defaults\":{\"desktop\":\"15px 15px 15px 15px\"}}]},\"titleGap\":{\"target\":\"ep_tabs_header\",\"responsive\":true,\"options\":[{\"label\":\"Title Gap\",\"control\":\"Range\",\"attribute\":\"titleGap\",\"css\":\"gap\",\"defaults\":{\"desktop\":\"5px\"}}]},\"titleAlignment\":{\"target\":\"ep_tabs_header\",\"responsive\":true,\"options\":[{\"label\":\"Alignment\",\"control\":\"ButtonGroup\",\"attribute\":\"titleAlignment\",\"css\":\"justify-content\",\"defaults\":{\"desktop\":\"flex-start\"},\"props\":{\"options\":[{\"icon\":\"editor-alignleft\",\"value\":\"flex-start\"},{\"icon\":\"editor-aligncenter\",\"value\":\"center\"},{\"icon\":\"editor-alignright\",\"value\":\"flex-end\"},{\"icon\":\"editor-justify\",\"value\":\"space-around\"}]}}]},\"savedStyling\":\".eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tabs_header {\\n                \\n                flex-basis: 15% ;\\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tabs_root {\\n                \\n                gap: 0px ;\\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_label {\\n                \\n                color: #1e1e1e;\\nfont-size: 17px ;\\n            }\\n            \\n\\n        \\n\\n         \\n\\n        \\n        \\n      .eplus_styles  .ep_label_main:hover .ep_label {\\n        color: #ffffff;\\n      }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_sub_label {\\n                \\n                color: #1e1e1e;\\nfont-size: 15px ;\\n            }\\n            \\n\\n        \\n\\n         \\n\\n        \\n        \\n      .eplus_styles  .ep_label_main:hover .ep_sub_label {\\n        color: #ffffff;\\n      }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_active_tab .ep_label {\\n                \\n                color: #ffffff;\\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_active_tab .ep_sub_label {\\n                \\n                color: #ffffff;\\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_label_main {\\n                \\n                background-image: linear-gradient(#f0f0f0, #f0f0f0);\\n            }\\n            \\n\\n        \\n\\n         \\n\\n        \\n            .eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_label_main:hover {\\n                background-image: linear-gradient(#007cba, #007cba);\\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_active_tab {\\n                \\n                background-image: linear-gradient(#007cba, #007cba);\\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tab_item_wrapper {\\n                \\n                background-image: linear-gradient(#f0f0f0, #f0f0f0);\\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_label_main {\\n                \\n                padding-top: 15px ;\\npadding-right: 15px ;\\npadding-bottom: 15px ;\\npadding-left: 15px ;\\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tab_item_wrapper {\\n                \\n                padding-top: 15px ;\\npadding-right: 15px ;\\npadding-bottom: 15px ;\\npadding-left: 15px ;\\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tabs_header {\\n                \\n                gap: 5px ;\\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tabs_header {\\n                \\n                justify-content: flex-start;\\n            }\",\"clientId\":\"b65d44db-b362-4894-bd2a-00280a70fe72\"},\"id\":\"ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72\",\"tabs\":[{\"label\":\"Billing\",\"subLabel\":\"Sub Label\",\"id\":\"ep_tab_wrapper__c003c393-d293-4a35-bf11-acca55853091\"},{\"label\":\"Review\",\"subLabel\":\"Sub Label\",\"id\":\"ep_tab_wrapper__c0592c1f-7dc1-4038-8466-bf1e47a24059\"},{\"label\":\"Payment\",\"subLabel\":\"Sub Label\",\"id\":\"ep_tab_wrapper__9eb11351-daca-424a-b3b3-436bb256f457\"}],\"tabsHeaderSizing\":{\"desktop\":{\"value\":15,\"important\":false,\"unit\":\"%\"},\"tablet\":{\"value\":\"\",\"important\":false,\"unit\":\"%\"},\"tabletModified\":false,\"mobile\":{\"value\":\"\",\"important\":false,\"unit\":\"%\"},\"mobileModified\":false},\"blockGap\":{\"desktop\":{\"value\":0,\"important\":false,\"unit\":\"px\"},\"tablet\":{\"value\":\"\",\"important\":false,\"unit\":\"%\"},\"tabletModified\":false,\"mobile\":{\"value\":\"\",\"important\":false,\"unit\":\"%\"},\"mobileModified\":false},\"titleAlignment\":{\"desktop\":\"flex-start\",\"tablet\":\"\",\"tabletModified\":false,\"mobile\":\"\",\"mobileModified\":false},\"titleGap\":{\"desktop\":{\"value\":5,\"important\":false,\"unit\":\"px\"},\"tablet\":{\"value\":\"\",\"important\":false,\"unit\":\"%\"},\"tabletModified\":false,\"mobile\":{\"value\":\"\",\"important\":false,\"unit\":\"%\"},\"mobileModified\":false},\"titleBorder\":{\"desktop\":{\"borderTop\":{},\"borderRight\":{},\"borderLeft\":{},\"borderBottom\":{},\"borderAll\":{}},\"tablet\":{\"borderTop\":{},\"borderRight\":{},\"borderLeft\":{},\"borderBottom\":{},\"borderAll\":{}},\"tabletModified\":false,\"mobile\":{\"borderTop\":{},\"borderRight\":{},\"borderLeft\":{},\"borderBottom\":{},\"borderAll\":{}},\"mobileModified\":false,\"hover\":{\"borderTop\":{},\"borderRight\":{},\"borderLeft\":{},\"borderBottom\":{},\"borderAll\":{}},\"hoverModified\":false},\"titleBorderRadius\":{\"desktop\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"tablet\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"tabletModified\":false,\"mobile\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"mobileModified\":false,\"hover\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"hoverModified\":false},\"titleBoxShadow\":{\"desktop\":{\"inset\":false,\"horizontal\":0,\"vertical\":0,\"blurRadius\":0,\"spreadRadius\":0,\"shadowColor\":\"rgba(50, 46, 46, 1)\",\"important\":false},\"tablet\":{\"inset\":false,\"horizontal\":0,\"vertical\":0,\"blurRadius\":0,\"spreadRadius\":0,\"shadowColor\":\"rgba(50, 46, 46, 1)\",\"important\":false},\"tabletModified\":false,\"mobile\":{\"inset\":false,\"horizontal\":0,\"vertical\":0,\"blurRadius\":0,\"spreadRadius\":0,\"shadowColor\":\"rgba(50, 46, 46, 1)\",\"important\":false},\"mobileModified\":false,\"hover\":{\"inset\":false,\"horizontal\":0,\"vertical\":0,\"blurRadius\":0,\"spreadRadius\":0,\"shadowColor\":\"rgba(50, 46, 46, 1)\",\"important\":false},\"hoverModified\":false},\"titleTypography\":{\"desktop\":{\"lineHeight\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontSize\":{\"value\":17,\"important\":false,\"unit\":\"px\"},\"letterSpacing\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"textStyle\":[],\"fontWeight\":null,\"underline\":{\"color\":\"\",\"style\":\"\"},\"textColor\":{\"color\":\"#1e1e1e\",\"imp\":false},\"lineThrough\":{\"color\":\"\",\"style\":\"\"},\"textAlignment\":\"\"},\"tablet\":{\"lineHeight\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontSize\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"letterSpacing\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontWeight\":null,\"textStyle\":[],\"textColor\":{\"color\":\"\",\"imp\":false},\"underline\":{\"color\":\"\",\"style\":\"\"},\"lineThrough\":{\"color\":\"\",\"style\":\"\"},\"textAlignment\":\"\"},\"tabletModified\":false,\"mobile\":{\"lineHeight\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontSize\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"letterSpacing\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontWeight\":null,\"textStyle\":[],\"textColor\":{\"color\":\"\",\"imp\":false},\"underline\":{\"color\":\"\",\"style\":\"\"},\"lineThrough\":{\"color\":\"\",\"style\":\"\"},\"textAlignment\":\"\"},\"mobileModified\":false,\"hover\":{\"lineHeight\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontSize\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"letterSpacing\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"textStyle\":[],\"fontWeight\":null,\"underline\":{\"color\":\"\",\"style\":\"\"},\"textColor\":{\"color\":\"#ffffff\",\"imp\":false},\"lineThrough\":{\"color\":\"\",\"style\":\"\"},\"textAlignment\":\"\"},\"hoverModified\":true},\"subTitleTypography\":{\"desktop\":{\"lineHeight\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontSize\":{\"value\":15,\"important\":false,\"unit\":\"px\"},\"letterSpacing\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"textStyle\":[],\"fontWeight\":null,\"underline\":{\"color\":\"\",\"style\":\"\"},\"textColor\":{\"color\":\"#1e1e1e\",\"imp\":false},\"lineThrough\":{\"color\":\"\",\"style\":\"\"},\"textAlignment\":\"\"},\"tablet\":{\"lineHeight\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontSize\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"letterSpacing\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontWeight\":null,\"textStyle\":[],\"textColor\":{\"color\":\"\",\"imp\":false},\"underline\":{\"color\":\"\",\"style\":\"\"},\"lineThrough\":{\"color\":\"\",\"style\":\"\"},\"textAlignment\":\"\"},\"tabletModified\":false,\"mobile\":{\"lineHeight\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontSize\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"letterSpacing\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontWeight\":null,\"textStyle\":[],\"textColor\":{\"color\":\"\",\"imp\":false},\"underline\":{\"color\":\"\",\"style\":\"\"},\"lineThrough\":{\"color\":\"\",\"style\":\"\"},\"textAlignment\":\"\"},\"mobileModified\":false,\"hover\":{\"lineHeight\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"fontSize\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"letterSpacing\":{\"value\":\"\",\"important\":false,\"unit\":\"px\"},\"textStyle\":[],\"fontWeight\":null,\"underline\":{\"color\":\"\",\"style\":\"\"},\"textColor\":{\"color\":\"#ffffff\",\"imp\":false},\"lineThrough\":{\"color\":\"\",\"style\":\"\"},\"textAlignment\":\"\"},\"hoverModified\":true},\"titleActiveColor\":{\"desktop\":{\"color\":\"#ffffff\"},\"tablet\":{\"color\":\"\"},\"tabletModified\":false,\"mobile\":{\"color\":\"\"},\"mobileModified\":false},\"subTitleActiveColor\":{\"desktop\":{\"color\":\"#ffffff\"},\"tablet\":{\"color\":\"\"},\"tabletModified\":false,\"mobile\":{\"color\":\"\"},\"mobileModified\":false},\"titleBackground\":{\"desktop\":{\"solid\":\"#f0f0f0\",\"gradient\":\"\",\"media\":{\"backgroundPositionX\":\"\",\"backgroundPositionY\":\"\",\"background\":{},\"backgroundSize\":\"\",\"backgroundRepeat\":\"\",\"backgroundAttachment\":\"\",\"backgroundPlacement\":\"back\"}},\"tablet\":{\"solid\":\"\",\"gradient\":\"\",\"media\":{\"backgroundPositionX\":\"\",\"backgroundPositionY\":\"\",\"background\":{},\"backgroundSize\":\"\",\"backgroundRepeat\":\"\",\"backgroundAttachment\":\"\",\"backgroundPlacement\":\"back\"}},\"tabletModified\":false,\"mobile\":{\"solid\":\"\",\"gradient\":\"\",\"media\":{\"backgroundPositionX\":\"\",\"backgroundPositionY\":\"\",\"background\":{},\"backgroundSize\":\"\",\"backgroundRepeat\":\"\",\"backgroundAttachment\":\"\",\"backgroundPlacement\":\"back\"}},\"mobileModified\":false,\"hover\":{\"solid\":\"#007cba\",\"gradient\":\"\",\"media\":{\"backgroundPositionX\":\"\",\"backgroundPositionY\":\"\",\"background\":{},\"backgroundSize\":\"\",\"backgroundRepeat\":\"\",\"backgroundAttachment\":\"\",\"backgroundPlacement\":\"back\"}},\"hoverModified\":true},\"titleActiveBackground\":{\"desktop\":{\"solid\":\"#007cba\",\"gradient\":\"\",\"media\":{\"backgroundPositionX\":\"\",\"backgroundPositionY\":\"\",\"background\":{},\"backgroundSize\":\"\",\"backgroundRepeat\":\"\",\"backgroundAttachment\":\"\",\"backgroundPlacement\":\"back\"}},\"tablet\":{\"solid\":\"\",\"gradient\":\"\",\"media\":{\"backgroundPositionX\":\"\",\"backgroundPositionY\":\"\",\"background\":{},\"backgroundSize\":\"\",\"backgroundRepeat\":\"\",\"backgroundAttachment\":\"\",\"backgroundPlacement\":\"back\"}},\"tabletModified\":false,\"mobile\":{\"solid\":\"\",\"gradient\":\"\",\"media\":{\"backgroundPositionX\":\"\",\"backgroundPositionY\":\"\",\"background\":{},\"backgroundSize\":\"\",\"backgroundRepeat\":\"\",\"backgroundAttachment\":\"\",\"backgroundPlacement\":\"back\"}},\"mobileModified\":false},\"contentBackground\":{\"desktop\":{\"solid\":\"#f0f0f0\",\"gradient\":\"\",\"media\":{\"backgroundPositionX\":\"\",\"backgroundPositionY\":\"\",\"background\":{},\"backgroundSize\":\"\",\"backgroundRepeat\":\"\",\"backgroundAttachment\":\"\",\"backgroundPlacement\":\"back\"}},\"tablet\":{\"solid\":\"\",\"gradient\":\"\",\"media\":{\"backgroundPositionX\":\"\",\"backgroundPositionY\":\"\",\"background\":{},\"backgroundSize\":\"\",\"backgroundRepeat\":\"\",\"backgroundAttachment\":\"\",\"backgroundPlacement\":\"back\"}},\"tabletModified\":false,\"mobile\":{\"solid\":\"\",\"gradient\":\"\",\"media\":{\"backgroundPositionX\":\"\",\"backgroundPositionY\":\"\",\"background\":{},\"backgroundSize\":\"\",\"backgroundRepeat\":\"\",\"backgroundAttachment\":\"\",\"backgroundPlacement\":\"back\"}},\"mobileModified\":false,\"hover\":{\"solid\":\"\",\"gradient\":\"\",\"media\":{\"backgroundPositionX\":\"\",\"backgroundPositionY\":\"\",\"background\":{},\"backgroundSize\":\"\",\"backgroundRepeat\":\"\",\"backgroundAttachment\":\"\",\"backgroundPlacement\":\"back\"}},\"hoverModified\":false},\"titlePadding\":{\"desktop\":{\"value\":{\"top\":\"15\",\"right\":\"15\",\"bottom\":\"15\",\"left\":\"15\"},\"unit\":\"px\",\"important\":false},\"tablet\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"tabletModified\":false,\"mobile\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"mobileModified\":false},\"contentBorder\":{\"desktop\":{\"borderTop\":{},\"borderRight\":{},\"borderLeft\":{},\"borderBottom\":{},\"borderAll\":{}},\"tablet\":{\"borderTop\":{},\"borderRight\":{},\"borderLeft\":{},\"borderBottom\":{},\"borderAll\":{}},\"tabletModified\":false,\"mobile\":{\"borderTop\":{},\"borderRight\":{},\"borderLeft\":{},\"borderBottom\":{},\"borderAll\":{}},\"mobileModified\":false,\"hover\":{\"borderTop\":{},\"borderRight\":{},\"borderLeft\":{},\"borderBottom\":{},\"borderAll\":{}},\"hoverModified\":false},\"contentBorderRadius\":{\"desktop\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"tablet\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"tabletModified\":false,\"mobile\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"mobileModified\":false,\"hover\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"hoverModified\":false},\"contentBoxShadow\":{\"desktop\":{\"inset\":false,\"horizontal\":0,\"vertical\":0,\"blurRadius\":0,\"spreadRadius\":0,\"shadowColor\":\"rgba(50, 46, 46, 1)\",\"important\":false},\"tablet\":{\"inset\":false,\"horizontal\":0,\"vertical\":0,\"blurRadius\":0,\"spreadRadius\":0,\"shadowColor\":\"rgba(50, 46, 46, 1)\",\"important\":false},\"tabletModified\":false,\"mobile\":{\"inset\":false,\"horizontal\":0,\"vertical\":0,\"blurRadius\":0,\"spreadRadius\":0,\"shadowColor\":\"rgba(50, 46, 46, 1)\",\"important\":false},\"mobileModified\":false,\"hover\":{\"inset\":false,\"horizontal\":0,\"vertical\":0,\"blurRadius\":0,\"spreadRadius\":0,\"shadowColor\":\"rgba(50, 46, 46, 1)\",\"important\":false},\"hoverModified\":false},\"contentPadding\":{\"desktop\":{\"value\":{\"top\":\"15\",\"right\":\"15\",\"bottom\":\"15\",\"left\":\"15\"},\"unit\":\"px\",\"important\":false},\"tablet\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"tabletModified\":false,\"mobile\":{\"value\":{\"top\":\"\",\"right\":\"\",\"bottom\":\"\",\"left\":\"\"},\"unit\":\"%\",\"important\":false},\"mobileModified\":false}} -->\n<div class=\"wp-block-ep-tabs ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72\"><div class=\"ep_tabs_root ep_tabs_top\" data-autoplay=\"false\" data-delay=\"1000\"><div class=\"ep_tabs_header \"><a href=\"#ep_tab_wrapper__c003c393-d293-4a35-bf11-acca55853091\" class=\"ep_label_main\"><span class=\"ep_label\">Billing</span></a><a href=\"#ep_tab_wrapper__c0592c1f-7dc1-4038-8466-bf1e47a24059\" class=\"ep_label_main\"><span class=\"ep_label\">Review</span></a><a href=\"#ep_tab_wrapper__9eb11351-daca-424a-b3b3-436bb256f457\" class=\"ep_label_main\"><span class=\"ep_label\">Payment</span></a></div><div class=\"ep_tabs_wrapper undefined\"><!-- wp:ep/tab-item {\"id\":\"ep_tab_wrapper__c003c393-d293-4a35-bf11-acca55853091\",\"label\":\"Billing\"} -->\n<div id=\"ep_tab_wrapper__c003c393-d293-4a35-bf11-acca55853091\" class=\"ep_tab_item_wrapper ep_tab_wrapper__c003c393-d293-4a35-bf11-acca55853091 undefined\"><!-- wp:launchflows/billing -->\n<div class=\"wp-block-launchflows-billing\">[lf-billing]</div>\n<!-- /wp:launchflows/billing --></div>\n<!-- /wp:ep/tab-item -->\n\n<!-- wp:ep/tab-item {\"id\":\"ep_tab_wrapper__c0592c1f-7dc1-4038-8466-bf1e47a24059\",\"label\":\"Review\",\"hide\":false} -->\n<div id=\"ep_tab_wrapper__c0592c1f-7dc1-4038-8466-bf1e47a24059\" class=\"ep_tab_item_wrapper ep_tab_wrapper__c0592c1f-7dc1-4038-8466-bf1e47a24059 undefined\"><!-- wp:launchflows/review -->\n<div class=\"wp-block-launchflows-review\">[lf-review]</div>\n<!-- /wp:launchflows/review --></div>\n<!-- /wp:ep/tab-item -->\n\n<!-- wp:ep/tab-item {\"id\":\"ep_tab_wrapper__9eb11351-daca-424a-b3b3-436bb256f457\",\"label\":\"Payment\"} -->\n<div id=\"ep_tab_wrapper__9eb11351-daca-424a-b3b3-436bb256f457\" class=\"ep_tab_item_wrapper ep_tab_wrapper__9eb11351-daca-424a-b3b3-436bb256f457 undefined\"><!-- wp:launchflows/payment -->\n<div class=\"wp-block-launchflows-payment\">[lf-payment]</div>\n<!-- /wp:launchflows/payment --></div>\n<!-- /wp:ep/tab-item --></div><style>.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tabs_header {\n                \n                flex-basis: 15% ;\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tabs_root {\n                \n                gap: 0px ;\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_label {\n                \n                color: #1e1e1e;\nfont-size: 17px ;\n            }\n            \n\n        \n\n         \n\n        \n        \n      .eplus_styles  .ep_label_main:hover .ep_label {\n        color: #ffffff;\n      }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_sub_label {\n                \n                color: #1e1e1e;\nfont-size: 15px ;\n            }\n            \n\n        \n\n         \n\n        \n        \n      .eplus_styles  .ep_label_main:hover .ep_sub_label {\n        color: #ffffff;\n      }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_active_tab .ep_label {\n                \n                color: #ffffff;\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_active_tab .ep_sub_label {\n                \n                color: #ffffff;\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_label_main {\n                \n                background-image: linear-gradient(#f0f0f0, #f0f0f0);\n            }\n            \n\n        \n\n         \n\n        \n            .eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_label_main:hover {\n                background-image: linear-gradient(#007cba, #007cba);\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_active_tab {\n                \n                background-image: linear-gradient(#007cba, #007cba);\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tab_item_wrapper {\n                \n                background-image: linear-gradient(#f0f0f0, #f0f0f0);\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_label_main {\n                \n                padding-top: 15px ;\npadding-right: 15px ;\npadding-bottom: 15px ;\npadding-left: 15px ;\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tab_item_wrapper {\n                \n                padding-top: 15px ;\npadding-right: 15px ;\npadding-bottom: 15px ;\npadding-left: 15px ;\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tabs_header {\n                \n                gap: 5px ;\n            }.eplus_styles .ep_tabs_wrapper__b65d44db-b362-4894-bd2a-00280a70fe72 .ep_tabs_header {\n                \n                justify-content: flex-start;\n            }</style></div></div>\n<!-- /wp:ep/tabs -->
                ", // end content
              )
            );
        // end block pattern              
        
    }
}